//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
//if(1)//Ont
AnsiString driverPath=ExtractFilePath(Application->ExeName)+"REGSYS.SYS";
  LoadDeviceDriver("REGMON",driverPath.c_str(),&SysHandle);
//else
  //SysHandle = CreateFile( "\\\\.\\REGVXD.VXD", 0, 0, NULL,0, FILE_FLAG_OVERLAPPED|FILE_FLAG_DELETE_ON_CLOSE,NULL );

DeviceIoControl(SysHandle,REGMON_zerostats,NULL,0,NULL,0,&nb,NULL);

//DWORD versionNumber;
//DeviceIoControl( SysHandle, REGMON_version,NULL, 0, &versionNumber, sizeof(DWORD), &nb, NULL );

FILTER FilterDefinition;
sprintf(FilterDefinition.processfilter, "*" );
strcpy(FilterDefinition.processexclude, "" );
sprintf(FilterDefinition.pathfilter,    "*" );
sprintf(FilterDefinition.excludefilter, "" );
FilterDefinition.logsuccess = TRUE;
FilterDefinition.logerror   = TRUE;
FilterDefinition.logreads   = TRUE;
FilterDefinition.logwrites  = TRUE;

DeviceIoControl(SysHandle, REGMON_setfilter,&FilterDefinition, sizeof(FILTER), NULL,0, &nb, NULL );

DeviceIoControl(SysHandle, REGMON_hook,NULL, 0, NULL, 0, &nb, NULL );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
DeviceIoControl( SysHandle, REGMON_unhook, NULL, 0, NULL, 0, &nb, NULL );
CloseHandle( SysHandle );
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
DWORD startTime;
char Stats[ MAX_STORE ];
DWORD StatsLen;
for(startTime = GetTickCount() ; GetTickCount() - startTime < 1000; )
  {DeviceIoControl( SysHandle, REGMON_getstats,NULL, 0, &Stats, sizeof(Stats),&StatsLen, NULL );
   if(!StatsLen)
     {//ListView1->Selected = ListView1->Items->Item[ListView1->Items->Count-1];
     ListView1->Perform(WM_VSCROLL , SB_BOTTOM ,0);
      return ;
     }
   PENTRY  ptr;
   bool IsNT=true;
   long index;
   char *min,*line,*item[10];
   //min(Stats+StatsLen , Stats + sizeof (Stats))
   if(StatsLen < sizeof (Stats))
     min=Stats+StatsLen;
   else
     min=Stats + sizeof (Stats);
   for ( ptr = (PENTRY)Stats; (char *)ptr < min; )
     {ULONG len = strlen(ptr->text);// Add to list
      if( IsNT )
        {len += 4;
         len &= 0xFFFFFFFC; // +1 for null-terminator +3 for 32bit alignment
        }
      for(index=0,line=ptr->text;;)
        {item[index++]=line;
         line=strchr(line,'\t');
         if(line==NULL)
           break;
         *line++='\0';
        }
      litem=ListView1->Items->Add();
      litem->Caption=item[0];
      litem->SubItems->Add(item[1]);
      litem->SubItems->Add(item[2]);
      litem->SubItems->Add(item[3]);
      litem->SubItems->Add(item[4]);

      if( IsNT ) ptr = (PENTRY)(ptr->text + len);
      else       ptr = (PENTRY)(ptr->text + len + 1);
     }
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
ListView1->Width=Form1->Width-24;
ListView1->Height=Form1->Height-90;
Button1->Top=Form1->Height-60;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer2Timer(TObject *Sender)
{
int ItemCount=ListView1->Items->Count;
if(ItemCount > 1000)
  {Timer1->Enabled=false;
   for(int i=0;i< ItemCount-700 ;i++)
     ListView1->Items->Delete(0); 
   Timer1->Enabled=true;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
if(Timer1->Enabled)
  Button1->Caption="Ұ";
else
  Button1->Caption="Ȱ";
Timer1->Enabled=!Timer1->Enabled;
}
//---------------------------------------------------------------------------

